
#include <vcl.h>
#pragma hdrstop

#include "ATxSProc.h"




#include "d2c_system.h"


void __fastcall SReplace( String& S, const String SFrom, const String STo )
{
  int i = 0;
  i = S.Pos( SFrom );
  if ( i > 0 )
  {
    S.Delete( i, SFrom.Length( ) );
    S.Insert( STo, i );
  }
}


String __fastcall SReplaceFunc( const String S, const String SFrom, const String STo )
{
  String result;
  result = S;
  SReplace( result, SFrom, STo );
  return result;
}


void __fastcall SReplaceW( WideString& S, const WideString SFrom, const WideString STo )
{
  int i = 0;
  i = S.Pos( SFrom );
  if ( i > 0 )
  {
    S.Delete( i, SFrom.Length( ) );
    S.Insert( STo, i );
  }
}


void __fastcall SReplaceAll( String& S, const String SFrom, const String STo )
{
  int i = 0;
  do
  {
    i = S.Pos( SFrom );
    if ( i == 0 )
      break;
    S.Delete( i, SFrom.Length( ) );
    S.Insert( STo, i );
  }
  while ( ! ( false ) );
}


void __fastcall SReplaceAllW( WideString& S, const WideString SFrom, const WideString STo )
{
  int i = 0;
  do
  {
    i = S.Pos( SFrom );
    if ( i == 0 )
      break;
    S.Delete( i, SFrom.Length( ) );
    S.Insert( STo, i );
  }
  while ( ! ( false ) );
}


void __fastcall SReplaceIAll( String& S, const String SFrom, const String STo )
{
  int i = 0;
  do
  {
    i = LowerCase( S ).Pos( LowerCase( SFrom ) );
    if ( i == 0 )
      break;
    S.Delete( i, SFrom.Length( ) );
    S.Insert( STo, i );
  }
  while ( ! ( false ) );
}


WideString __fastcall SDecodeW( const WideString S, const TStringDecodeRec* Decode, int Decode_maxidx )
{
  WideString result;
  int i = 0, j = 0;
  bool DoDecode = false;
  result.Empty();
  i = 1;
  do
  {
    if ( i > S.Length( ) )
      break;
    DoDecode = false;
    for ( int stop = Decode_maxidx /*# High(Decode) */, j = 0 /*# Low(Decode) */; j <= stop; j++)
      /*# with Decode[j] do */
      {
        const TStringDecodeRec& with0 = Decode[j];
        if ( with0.SFrom == S.SubString( i, with0.SFrom.Length( ) ) )
        {
          DoDecode = true;
          result = result + with0.STo;
          i += with0.SFrom.Length( );
          break;
        }
      }
    if ( DoDecode )
      continue;
    result = result + WideString( S[i] );
    i++;
  }
  while ( ! ( false ) );
  return result;
}


WideString __fastcall SFormatW( const WideString Msg, const WideString* Params, int Params_maxidx )
{
  WideString result;
  int i = 0;
  result = Msg;
  for ( int stop = Params_maxidx /*# High(Params) */, i = 0 /*# Low(Params) */; i <= stop; i++)
    SReplaceW( result, L"%s", Params[i] );
  return result;
}


WideString __fastcall SFormatWD( const WideString Msg, const int* Params, int Params_maxidx )
{
  WideString result;
  int i = 0;
  result = Msg;
  for ( int stop = Params_maxidx /*# High(Params) */, i = 0 /*# Low(Params) */; i <= stop; i++)
    SReplaceW( result, L"%d", IntToStr( Params[i] ) );
  return result;
}


int __fastcall LastDelimiter( const WideString Delimiters, const WideString S )
{
  int result = 0;
  int i = 0;
  for ( int stop = 1, i = S.Length( ); i >= stop; i--)
    if ( Delimiters.Pos( WideString( S[i] ) ) > 0 )
    {
      result = i;
      return result;
    }
  result = 0;
  return result;
}


WideString __fastcall SExtractFileDir( const WideString Filename )
{
  WideString result;
  int i = 0;
  i = LastDelimiter( L"\\:", Filename );
  if 
    //and (not (AnsiChar(FileName[I - 1]) in ['\', ':'])) //was in SysUtils!
  ( ( i > 1 ) && ( Filename[i] == L'\\' ) )
    i--;
  result = Filename.SubString( 1, i );
  return result;
}


WideString __fastcall SExtractFilePath( const WideString Filename )
{
  WideString result;
  int i = 0;
  i = LastDelimiter( L"\\:", Filename );
  result = Filename.SubString( 1, i );
  return result;
}


WideString __fastcall SExtractFileExt( const WideString Filename )
{
  WideString result;
  int i = 0;
  i = LastDelimiter( L".\\:", Filename );
  if ( ( i > 0 ) && ( Filename[i] == L'.' ) )
    result = Filename.SubString( i, MaxInt );
  else
    result.Empty();
  return result;
}


WideString __fastcall SExtractFileName( const WideString Filename )
{
  WideString result;
  int i = 0;
  i = LastDelimiter( L"\\:", Filename );
  result = Filename.SubString( i + 1, MaxInt );
  return result;
}


int __fastcall SCompareIW( const WideString s1, const WideString s2 )
{
  int result = 0;
  if ( Win32Platform == VER_PLATFORM_WIN32_NT )
    result = lstrcmpiW( s1.c_bstr(), s2.c_bstr());
  else
    result = lstrcmpiA( ((AnsiString) s1 ).c_str(), ((AnsiString) s2 ).c_str());
  return result;
}


AnsiString __fastcall SDefaultDelimiters( )
{
  AnsiString result;
  char* Chars = ":;<=>?" "@[\\]^" "`{|}~";
  int i = 0;
  result = "";
  for ( int stop = int( '/' ), i = 0; i <= stop; i++)
    result = result + ((char) Char( i ) );
  result = result + Chars;
  return result;
}

//--------------------------------------------------



WideString __fastcall AnsiLowerCaseW( const WideString S )
{
  WideString result;
  result = S;
  if ( !result.IsEmpty())
  {
    if ( Win32Platform == VER_PLATFORM_WIN32_NT )
      CharLowerBuffW( &result[1], result.Length( ) );
    else
      result = AnsiLowerCase( S );
  }
  return result;
}

//--------------------------------------------------



int __fastcall SFindText( const AnsiString F, const AnsiString S, bool fForward, bool fWholeWords, bool fCaseSens, bool fLastBlock )
{
  int result = 0;
  AnsiString SBuf, FBuf, Delimiters;
  bool Match = false;
  int LastPos = 0, LengthF = 0, i = 0;
  result = 0;
  if ( ( S.IsEmpty()) || ( F.IsEmpty()) )
    return result;
  Delimiters = SDefaultDelimiters();
  SBuf = S;
  FBuf = F;
  if ( ! fCaseSens )
  {
    SBuf = AnsiLowerCase( SBuf );
    FBuf = AnsiLowerCase( FBuf );
  }
  LengthF = F.Length( );
  LastPos = S.Length( ) - LengthF + 1;
  if ( fForward )
    //Search forward
    for ( int stop = LastPos, i = 1; i <= stop; i++)
    {
      Match = CompareMem( &FBuf[1], &SBuf[i], LengthF );
      if ( fWholeWords )
        Match = Match && ( fLastBlock || ( i < LastPos ) ) && ( ( i <= 1 ) || ( Delimiters.Pos( S[i - 1] ) > 0 ) ) && ( ( i >= LastPos ) || ( Delimiters.Pos( S[i + LengthF] ) > 0 ) );
      if ( Match )
      {
        result = i;
        break;
      }
    }
  else
    //Search backward
    for ( int stop = 1, i = LastPos; i >= stop; i--)
    {
      Match = CompareMem( &FBuf[1], &SBuf[i], LengthF );
      if ( fWholeWords )
        Match = Match && ( fLastBlock || ( i > 1 ) ) && ( ( i <= 1 ) || ( Delimiters.Pos( S[i - 1] ) > 0 ) ) && ( ( i >= LastPos ) || ( Delimiters.Pos( S[i + LengthF] ) > 0 ) );
      if ( Match )
      {
        result = i;
        break;
      }
    }
  return result;
}

//--------------------------------------------------



int __fastcall SFindTextW( const WideString F, const WideString S, bool fForward, bool fWholeWords, bool fCaseSens, bool fLastBlock )
{
  int result = 0;
  WideString SBuf, FBuf, Delimiters;
  bool Match = false;
  int LastPos = 0, LengthF = 0, i = 0;
  result = 0;
  if ( ( S.IsEmpty()) || ( F.IsEmpty()) )
    return result;
  Delimiters = SDefaultDelimiters();
  SBuf = S;
  FBuf = F;
  if ( ! fCaseSens )
  {
    SBuf = AnsiLowerCaseW( SBuf );
    FBuf = AnsiLowerCaseW( FBuf );
  }
  LengthF = F.Length( );
  LastPos = S.Length( ) - LengthF + 1;
  if ( fForward )
    //Search forward
    for ( int stop = LastPos, i = 1; i <= stop; i++)
    {
      Match = CompareMem( &FBuf[1], &SBuf[i], LengthF * 2 );
      if ( fWholeWords )
        Match = Match && ( fLastBlock || ( i < LastPos ) ) && ( ( i <= 1 ) || ( Delimiters.Pos( WideString( S[i - 1] ) ) > 0 ) ) && ( ( i >= LastPos ) || ( Delimiters.Pos( WideString( S[i + LengthF] ) ) > 0 ) );
      if ( Match )
      {
        result = i;
        break;
      }
    }
  else
    //Search backward
    for ( int stop = 1, i = LastPos; i >= stop; i--)
    {
      Match = CompareMem( &FBuf[1], &SBuf[i], LengthF * 2 );
      if ( fWholeWords )
        Match = Match && ( fLastBlock || ( i > 1 ) ) && ( ( i <= 1 ) || ( Delimiters.Pos( WideString( S[i - 1] ) ) > 0 ) ) && ( ( i >= LastPos ) || ( Delimiters.Pos( WideString( S[i + LengthF] ) ) > 0 ) );
      if ( Match )
      {
        result = i;
        break;
      }
    }
  return result;
}


int __fastcall IMin( int N1, int N2 )
{
  int result = 0;
  if ( N1 < N2 )
    result = N1;
  else
    result = N2;
  return result;
}


int __fastcall IMax( int N1, int N2 )
{
  int result = 0;
  if ( N1 > N2 )
    result = N1;
  else
    result = N2;
  return result;
}


WORD __fastcall WMin( WORD N1, WORD N2 )
{
  WORD result = 0;
  if ( N1 < N2 )
    result = N1;
  else
    result = N2;
  return result;
}


WORD __fastcall wMax( WORD N1, WORD N2 )
{
  WORD result = 0;
  if ( N1 > N2 )
    result = N1;
  else
    result = N2;
  return result;
}


__int64 __fastcall I64Min( const __int64 N1, const __int64 N2 )
{
  __int64 result = 0;
  if ( N1 < N2 )
    result = N1;
  else
    result = N2;
  return result;
}


__int64 __fastcall I64Max( const __int64 N1, const __int64 N2 )
{
  __int64 result = 0;
  if ( N1 > N2 )
    result = N1;
  else
    result = N2;
  return result;
}


void __fastcall ILimitMin( int& n, int Value )
{
  if ( n < Value )
    n = Value;
}


void __fastcall ILimitMax( int& n, int Value )
{
  if ( n > Value )
    n = Value;
}

/*
procedure WLimitMin(var N: Word; Value: Word);
begin
  if N < Value then
    N := Value;
end;

procedure WLimitMax(var N: Word; Value: Word);
begin
  if N > Value then
    N := Value;
end;
*/


void __fastcall I64LimitMin( __int64& n, const __int64 Value )
{
  if ( n < Value )
    n = Value;
}


void __fastcall I64LimitMax( __int64& n, const __int64 Value )
{
  if ( n > Value )
    n = Value;
}


void __fastcall SReplaceZeros( AnsiString& S )
{
  int i = 0;
  for ( int stop = S.Length( ), i = 1; i <= stop; i++)
    if ( S[i] == '\x00' )
      S[i] = ' ';
}


void __fastcall SReplaceZerosW( WideString& S )
{
  int i = 0;
  for ( int stop = S.Length( ), i = 1; i <= stop; i++)
    if ( S[i] == L'\x00' )
      S[i] = L' ';
}


void __fastcall SDelLastSpaceW( WideString& S )
{
  if ( ( !S.IsEmpty()) && ( ( S[S.Length( )] == L' ' ) || ( S[S.Length( )] == L'\x09' ) ) )
    S.SetLength( S.Length( ) - 1 );
}


void __fastcall SDelLastSpace( AnsiString& S )
{
  if ( ( !S.IsEmpty()) && ( S[S.Length( )] == ' ' ) )
    S.SetLength( S.Length( ) - 1 );
}


void __fastcall SDelLastSlashW( WideString& S )
{
  if ( ( !S.IsEmpty()) && ( S[S.Length( )] == L'\\' ) )
    S.SetLength( S.Length( ) - 1 );
}


void __fastcall SDelLastSlash( AnsiString& S )
{
  if ( ( !S.IsEmpty()) && ( S[S.Length( )] == '\\' ) )
    S.SetLength( S.Length( ) - 1 );
}


void __fastcall SDelLastComma( AnsiString& S )
{
  if ( ( !S.IsEmpty()) && ( S[S.Length( )] == ',' ) )
    S.SetLength( S.Length( ) - 1 );
}


WideString __fastcall SFillW( wchar_t Ch, int Count )
{
  WideString result;
  int i = 0;
  result.SetLength( Count );
  for ( int stop = result.Length( ), i = 1; i <= stop; i++)
    result[i] = Ch;
  return result;
}


WideString __fastcall STabReplacement( const TStringTabOptions& TabOptions )
{
  WideString result;
  int ASize = 0;
  int APos = 0;
  /*# with TabOptions do */
  {
    Assert( TabOptions.TabSize > 0, "Tab size too small" );
    if ( TabOptions.FontMonospaced )
      ASize = TabOptions.TabSize - ( TabOptions.TabPosition - 1 ) % TabOptions.TabSize;
    else
      ASize = TabOptions.TabSize;
    result = SFillW( L' ', ASize );
    APos = result.Length( ) / 2 + 1;
    if ( TabOptions.NonPrintableShow )
      result[APos] = TabOptions.NonPrintableChar;
  }
  return result;
}


void __fastcall SReplaceTabsW( WideString& S, TStringTabOptions& TabOptions )
{
  int n = 0;
  do
  {
    n = S.Pos( "\x09" );
    if ( n == 0 )
      break;
    TabOptions.TabPosition = n;
    SReplaceW( S, L"\x09", STabReplacement( TabOptions ) );
  }
  while ( ! ( false ) );
}


WideString __fastcall SetStringW( char* Buffer, int BufSize, bool SwapBytes )
{
  WideString result;
  char* P = NULL;
  int i = 0, j = 0;
  char Ch = '\0';
  result.Empty();
  if ( BufSize < 2 )
    return result;
  result.SetLength( BufSize / 2 );
  Move( Buffer, &result[1], result.Length( ) * 2 );
  if ( SwapBytes )
  {
	P = (char*) &result[1];
    for ( int stop = result.Length( ), i = 1; i <= stop; i++)
    {
      j = ( i - 1 ) * 2;
      Ch = P[j];
      P[j] = P[j + 1];
      P[j + 1] = Ch;
    }
  }
  return result;
}


bool __fastcall SFileExtensionMatch( const WideString Filename, const AnsiString ExtList )
{
  bool result = false;
  AnsiString Ext;
  Ext = SExtractFileExt( Filename );
  if ( ( !Ext.IsEmpty()) && ( Ext[1] == '.' ) )
    Ext.Delete( 1, 1 );
  result = String( String( "," ) + LowerCase( ExtList ) + "," ).Pos( String( "," ) + LowerCase( Ext ) + "," ) > 0;
  return result;
}


void __fastcall SDeleteFromStrA( AnsiString& S, const AnsiString Substr )
{
  int n = 0;
  n = S.Pos( Substr );
  if ( n > 0 )
    S.SetLength( n - 1 );
}


void __fastcall SDeleteFromStrW( WideString& S, const WideString Substr )
{
  int n = 0;
  n = S.Pos( Substr );
  if ( n > 0 )
    S.SetLength( n - 1 );
}


bool __fastcall SCharCR( wchar_t Ch )
{
  bool result = false;
  result = ( Ch == L'\x0d' ) || ( Ch == L'\x0a' );
  return result;
}


bool __fastcall SLastCharCR( const WideString S )
{
  bool result = false;
  result = ( !S.IsEmpty()) && SCharCR( S[S.Length( )] );
  return result;
}

//--------------------------------------------------------



WideString __fastcall SExpandVars( const WideString S )
{
  WideString result;
  const int BufSize = 4 * 1024;
  char BufferA[ 4096/*# range 0..BufSize-1*/ ];
  wchar_t BufferW[ 4096/*# range 0..BufSize-1*/ ];
  if ( Win32Platform == VER_PLATFORM_WIN32_NT )
  {
    FillChar( BufferW, sizeof( BufferW ), 0 );
    ExpandEnvironmentStringsW( ((PWChar) S.c_bstr()), BufferW, BufSize );
    result = ((WideString) BufferW );
  }
  else
  {
    FillChar( BufferA, sizeof( BufferA ), 0 );
    ExpandEnvironmentStringsA( ((AnsiString) S ).c_str(), BufferA, BufSize );
    result = ((AnsiString) BufferA );
  }
  return result;
}


bool __fastcall SExpanded( const WideString S )
{
  bool result = false;
  result = S.Pos( "%" ) == 0;
  return result;
}
