#ifndef ATxSProcH
#define ATxSProcH


#include "d2c_system.h"

#include <windows.hpp>
#include <sysutils.hpp>



struct TStringDecodeRec;
struct TStringTabOptions;


WideString __fastcall SExpandVars( const WideString S );
bool __fastcall SExpanded( const WideString S );
void __fastcall SReplace( String& S, const String SFrom, const String STo );
void __fastcall SReplaceW( WideString& S, const WideString SFrom, const WideString STo );
void __fastcall SReplaceAll( String& S, const String SFrom, const String STo );
void __fastcall SReplaceAllW( WideString& S, const WideString SFrom, const WideString STo );
void __fastcall SReplaceIAll( String& S, const String SFrom, const String STo );


struct TStringDecodeRec {
  AnsiString SFrom, STo;
};


struct TStringTabOptions {
  int TabSize;
  int TabPosition;
  bool FontMonospaced;
  bool NonPrintableShow;
  wchar_t NonPrintableChar;
};


WideString __fastcall SDecodeW( const WideString S, const TStringDecodeRec* Decode, int Decode_maxidx );
void __fastcall SReplaceZeros( AnsiString& S );
void __fastcall SReplaceZerosW( WideString& S );
void __fastcall SDelLastSpace( AnsiString& S );
void __fastcall SDelLastSpaceW( WideString& S );
void __fastcall SDelLastSlash( AnsiString& S );
void __fastcall SDelLastSlashW( WideString& S );
void __fastcall SDelLastComma( AnsiString& S );
WideString __fastcall STabReplacement( const TStringTabOptions& TabOptions );
void __fastcall SReplaceTabsW( WideString& S, TStringTabOptions& TabOptions );
bool __fastcall SCharCR( wchar_t Ch );
bool __fastcall SLastCharCR( const WideString S );
WideString __fastcall SFormatW( const WideString Msg, const WideString* Params, int Params_maxidx );
WideString __fastcall SFormatWD( const WideString Msg, const int* Params, int Params_maxidx );
int __fastcall SCompareIW( const WideString s1, const WideString s2 );
WideString __fastcall SetStringW( char* Buffer, int BufSize, bool SwapBytes );
void __fastcall SDeleteFromStrA( AnsiString& S, const AnsiString Substr );
void __fastcall SDeleteFromStrW( WideString& S, const WideString Substr );
WideString __fastcall SExtractFileDir( const WideString Filename );
WideString __fastcall SExtractFilePath( const WideString Filename );
WideString __fastcall SExtractFileExt( const WideString Filename );
WideString __fastcall SExtractFileName( const WideString Filename );
int __fastcall SFindText( const AnsiString F, const AnsiString S, bool fForward, bool fWholeWords, bool fCaseSens, bool fLastBlock );
int __fastcall SFindTextW( const WideString F, const WideString S, bool fForward, bool fWholeWords, bool fCaseSens, bool fLastBlock );
int __fastcall IMin( int N1, int N2 );
int __fastcall IMax( int N1, int N2 );
WORD __fastcall WMin( WORD N1, WORD N2 );
WORD __fastcall wMax( WORD N1, WORD N2 );
__int64 __fastcall I64Min( const __int64 N1, const __int64 N2 );
__int64 __fastcall I64Max( const __int64 N1, const __int64 N2 );
void __fastcall ILimitMin( int& n, int Value );
void __fastcall ILimitMax( int& n, int Value );
void __fastcall I64LimitMin( __int64& n, const __int64 Value );
void __fastcall I64LimitMax( __int64& n, const __int64 Value );
bool __fastcall SFileExtensionMatch( const WideString Filename, const AnsiString ExtList );

#endif //  ATxSProcH