
#include <vcl.h>
#pragma hdrstop

#include "ATFileNotificationSimple.h"



#include "ATxFProc.h"



#include "d2c_system.h"

/* Helper functions */


void __fastcall FGetFileRec( const WideString Filename, TATFileSimpleRec& Rec )
{
  void* h = 0;
  TWin32FindDataA fdA;
  TWin32FindDataW fdW;
  FillChar( &Rec, sizeof( Rec ), 0 );
  if ( Win32Platform == VER_PLATFORM_WIN32_NT )
  {
    h = FindFirstFileW( Filename.c_bstr(), &fdW );
    Rec.FExist = h != INVALID_HANDLE_VALUE;
    if ( Rec.FExist )
    {
      Rec.FSizeLow = fdW.nFileSizeLow;
      Rec.FSizeHigh = fdW.nFileSizeHigh;
      //Rec.FAttr := fdW.dwFileAttributes;
      Rec.FTimeWr = fdW.ftLastWriteTime;
      //Rec.FTimeCr := fdW.ftCreationTime;
      //Rec.FTimeAcc := fdW.ftLastAccessTime;
      /*# Windows */::FindClose( h );
    }
  }
  else
  {
    h = FindFirstFileA( ((AnsiString) Filename ).c_str(), &fdA );
    Rec.FExist = h != INVALID_HANDLE_VALUE;
    if ( Rec.FExist )
    {
      Rec.FSizeLow = fdA.nFileSizeLow;
      Rec.FSizeHigh = fdA.nFileSizeHigh;
      //Rec.FAttr := fdA.dwFileAttributes;
      Rec.FTimeWr = fdA.ftLastWriteTime;
      //Rec.FTimeCr := fdA.ftCreationTime;
      //Rec.FTimeAcc := fdA.ftLastAccessTime;
      /*# Windows */::FindClose( h );
    }
  }
}


bool __fastcall FFileChanged( const WideString Filename, TATFileSimpleRec& OldRec )
{
  bool result = false;
  TATFileSimpleRec NewRec;
  CloseHandle( FFileOpen( Filename ) ); //To update filetime, if log is still open
  FGetFileRec( Filename, NewRec );
  result = ( OldRec.FExist != NewRec.FExist ) || ( OldRec.FSizeLow != NewRec.FSizeLow ) || ( OldRec.FSizeHigh != NewRec.FSizeHigh ) || ( OldRec.FTimeWr.dwLowDateTime != NewRec.FTimeWr.dwLowDateTime ) || ( OldRec.FTimeWr.dwHighDateTime != NewRec.FTimeWr.dwHighDateTime );
  if ( result )
    Move( &NewRec, &OldRec, sizeof( NewRec ) );
  return result;
}


/* TATFileNotificationSimple */


__fastcall TATFileNotificationSimple::TATFileNotificationSimple( TComponent* AOwner )
: inherited( AOwner )
{
  FFileName.Empty();
  FillChar( &FFileRec, sizeof( FFileRec ), 0 );
  FTimer = new TTimer( this );
  /*# with FTimer do */
  {
    FTimer->Enabled = false;
    FTimer->Interval = 1000;
    FTimer->OnTimer = TimerTimer;
  }
  FTimerBusy = false;
}


void __fastcall TATFileNotificationSimple::SetFileName( const WideString AValue )
{
  bool En = false;
  En = FTimer->Enabled;
  FTimer->Enabled = false;
  FFileName = AValue;
  FGetFileRec( FFileName, FFileRec );
  if ( ! FFileRec.FExist )
    throw Exception( "File to watch doesn't exist" );
  FTimer->Enabled = En;
}


void __fastcall TATFileNotificationSimple::TimerTimer( TObject* Sender )
{
  if ( ! FTimerBusy )
    try
    {
      FTimerBusy = true;
      if ( FFileChanged( FFileName, FFileRec ) )
        DoChanged();
    }
    __finally
    {
      FTimerBusy = false;
    }
}


void __fastcall TATFileNotificationSimple::DoChanged( )
{
  if (( FOnChanged != NULL ) )
    FOnChanged( this );
}


/* Registration */


void __fastcall Register( )
{
  TComponentClass classes[ 2 ] = { __classid( TATFileNotificationSimple) };
  RegisterComponents( "Samples" , classes,  1 );
}
