
#include <vcl.h>
#pragma hdrstop

#include "ATxFProc.h"



#include <sysutils.hpp>
#include <shellapi.hpp>



#include "d2c_system.h"


bool __fastcall IsFileExist( const WideString Filename, bool& IsDir ) /*# overload */
{
  bool result = false;
  void* h = 0;
  TWin32FindDataA fdA;
  TWin32FindDataW fdW;
  IsDir = false;
  if ( Win32Platform == VER_PLATFORM_WIN32_NT )
  {
    h = FindFirstFileW( Filename.c_bstr(), &fdW );
    result = h != INVALID_HANDLE_VALUE;
    if ( result )
    {
      IsDir = ( ( fdW.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) ) != 0;
      /*# Windows */::FindClose( h );
    }
  }
  else
  {
    h = FindFirstFileA( ((AnsiString) Filename ).c_str(), &fdA );
    result = h != INVALID_HANDLE_VALUE;
    if ( result )
    {
      IsDir = ( ( fdA.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) ) != 0;
      /*# Windows */::FindClose( h );
    }
  }
  return result;
}


bool __fastcall IsFileExist( const WideString Filename ) /*# overload */
{
  bool result = false;
  bool IsDir = false;
  result = IsFileExist( Filename, IsDir ) && ( ! IsDir );
  return result;
}


bool __fastcall IsFileOrDirExist( const WideString Filename )
{
  bool result = false;
  bool IsDir = false;
  result = IsFileExist( Filename, IsDir );
  return result;
}


WideString __fastcall SDelLastSlashW( const WideString S )
{
  WideString result;
  result = S;
  if ( ( !result.IsEmpty()) && ( result[result.Length( )] == L'\\' ) )
    result.SetLength( result.Length( ) - 1 );
  return result;
}


bool __fastcall IsDirExist( const WideString DirName ) /*# overload */
{
  bool result = false;
  bool IsDir = false;
  result = IsFileExist( SDelLastSlashW( DirName ), IsDir ) && IsDir;
  return result;
}


void* __fastcall FFileOpen( const WideString Filename )
{
  void* result = 0;
  if ( Win32Platform == VER_PLATFORM_WIN32_NT )
    result = CreateFileW( Filename.c_bstr(), GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, NULL, OPEN_EXISTING, 0, 0 );
  else
    result = CreateFileA( ((AnsiString) Filename ).c_str(), GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, 0 ); //FILE_SHARE_DELETE not supported under Win9x
  return result;
}


bool __fastcall FFileCopy( const WideString OldName, const WideString newName )
{
  bool result = false;
  if ( Win32Platform == VER_PLATFORM_WIN32_NT )
    result = CopyFileW( OldName.c_bstr(), newName.c_bstr(), false );
  else
    result = CopyFileA( ((AnsiString) OldName ).c_str(), ((AnsiString) newName ).c_str(), false );
  return result;
}


bool __fastcall FFileMove( const WideString OldName, const WideString newName )
{
  bool result = false;
  if ( Win32Platform == VER_PLATFORM_WIN32_NT )
    result = MoveFileW( OldName.c_bstr(), newName.c_bstr());
  else
    result = MoveFileA( ((AnsiString) OldName ).c_str(), ((AnsiString) newName ).c_str());
  return result;
}


bool __fastcall IsFileAccessed( const WideString Filename )
{
  bool result = false;
  void* h = 0;
  h = FFileOpen( Filename );
  result = h != INVALID_HANDLE_VALUE;
  if ( result )
    CloseHandle( h );
  return result;
}


__int64 __fastcall FGetFileSize( const WideString Filename ) /*# overload */
{
  __int64 result = 0;
  void* h = 0;
  TWin32FindDataA fdA;
  TWin32FindDataW fdW;
  TInt64Rec& SizeRec = *(TInt64Rec*) &result;
  result = - 1;
  if ( Win32Platform == VER_PLATFORM_WIN32_NT )
  {
    h = FindFirstFileW( Filename.c_bstr(), &fdW );
    if ( h != INVALID_HANDLE_VALUE )
    {
      SizeRec.Hi = fdW.nFileSizeHigh;
      SizeRec.Lo = fdW.nFileSizeLow;
      /*# Windows */::FindClose( h );
    }
  }
  else
  {
    h = FindFirstFileA( ((AnsiString) Filename ).c_str(), &fdA );
    if ( h != INVALID_HANDLE_VALUE )
    {
      SizeRec.Hi = fdA.nFileSizeHigh;
      SizeRec.Lo = fdA.nFileSizeLow;
      /*# Windows */::FindClose( h );
    }
  }
  return result;
}


__int64 __fastcall FGetFileSize( void* Handle ) /*# overload */
{
  __int64 result = 0;
  __int64 Size = 0;
  TInt64Rec& SizeRec = *(TInt64Rec*) &Size;
  SizeRec.Lo = GetFileSize( Handle, &SizeRec.Hi );
  if ( ( SizeRec.Lo == 0xFFFFFFFF ) && ( GetLastError() != NO_ERROR ) )
    result = - 1;
  else
    result = Size;
  return result;
}


bool __fastcall FGetFileInfo( const WideString Filename, __int64& Size, TFileTime& Time )
{
  bool result = false;
  void* h = 0;
  TWin32FindDataA fdA;
  TWin32FindDataW fdW;
  TInt64Rec& SizeRec = *(TInt64Rec*) &Size;
  result = false;
  Size = 0;
  FillChar( &Time, sizeof( Time ), 0 );
  if ( Win32Platform == VER_PLATFORM_WIN32_NT )
  {
    h = FindFirstFileW( Filename.c_bstr(), &fdW );
    if ( h != INVALID_HANDLE_VALUE )
    {
      result = true;
      //Attr := fdW.dwFileAttributes;
      SizeRec.Hi = fdW.nFileSizeHigh;
      SizeRec.Lo = fdW.nFileSizeLow;
      Time = fdW.ftLastWriteTime;
      /*# Windows */::FindClose( h );
    }
  }
  else
  {
    h = FindFirstFileA( ((AnsiString) Filename ).c_str(), &fdA );
    if ( h != INVALID_HANDLE_VALUE )
    {
      result = true;
      //Attr := fdA.dwFileAttributes;
      SizeRec.Hi = fdA.nFileSizeHigh;
      SizeRec.Lo = fdA.nFileSizeLow;
      Time = fdA.ftLastWriteTime;
      /*# Windows */::FindClose( h );
    }
  }
  return result;
}


WideString __fastcall FGetShortName( const WideString Filename )
{
  WideString result;
  char bufA[ 260/*# range 0..MAX_PATH-1*/ ];
  wchar_t bufW[ 260/*# range 0..MAX_PATH-1*/ ];
  AnsiString resA;
  if ( Win32Platform == VER_PLATFORM_WIN32_NT )
  {
    FillChar( bufW, sizeof( bufW ), 0 );
    SetString( result, bufW, GetShortPathNameW( Filename.c_bstr(), bufW, sizeof( bufW ) / 2 ) );
  }
  else
  {
    FillChar( bufA, sizeof( bufA ), 0 );
    SetString( resA, bufA, GetShortPathNameA( ((AnsiString) Filename ).c_str(), bufA, sizeof( bufA ) ) );
    result = resA;
  }
  return result;
}


bool __fastcall FOpenURL( const WideString URL, void* HWND )
{
  bool result = false;
  if ( Win32Platform == VER_PLATFORM_WIN32_NT )
    result = ShellExecuteW( HWND, L"open", URL.c_bstr(), NULL, NULL, SW_SHOW ) > 32;
  else
    result = ShellExecuteA( HWND, "open", ((AnsiString) URL ).c_str(), NULL, NULL, SW_SHOW ) > 32;
  return result;
}


bool __fastcall FExecute( const WideString Command, const WideString Params, void* HWND )
{
  bool result = false;
  if ( Win32Platform == VER_PLATFORM_WIN32_NT )
    result = ShellExecuteW( HWND, L"open", Command.c_bstr(), Params.c_bstr(), NULL, SW_SHOW ) > 32;
  else
    result = ShellExecuteA( HWND, "open", ((AnsiString) Command ).c_str(), ((AnsiString) Params ).c_str(), NULL, SW_SHOW ) > 32;
  return result;
}


bool __fastcall FCreateDir( const WideString Filename )
{
  bool result = false;
  if ( Win32Platform == VER_PLATFORM_WIN32_NT )
    result = CreateDirectoryW( Filename.c_bstr(), NULL );
  else
    result = CreateDirectoryA( ((AnsiString) Filename ).c_str(), NULL );
  return result;
}


bool __fastcall IsFileUnicode( void* h )
{
  bool result = false;
  WORD Buffer = 0;
  DWORD BytesRead = 0;
  Buffer = 0;
  SetFilePointer( h, 0, NULL, FILE_BEGIN );
  result = ReadFile( h, &Buffer, sizeof( Buffer ), &BytesRead, NULL ) && ( BytesRead >= sizeof( Buffer ) ) && ( ( Buffer == 0xFEFF ) || ( Buffer == 0xFFFE ) );
  return result;
}


bool __fastcall IsFileUTF8( void* h )
{
  bool result = false;
  #pragma pack(push, 1)
  unsigned char Buffer[ 3/*# range 0..2*/ ];
  #pragma pack(pop)
  DWORD BytesRead = 0;
  FillChar( Buffer, sizeof( Buffer ), 0 );
  SetFilePointer( h, 0, NULL, FILE_BEGIN );
  result = ReadFile( h, Buffer, sizeof( Buffer ), &BytesRead, NULL ) && ( BytesRead >= sizeof( Buffer ) ) && ( ( Buffer[0] == 0xEF ) && ( Buffer[1] == 0xBB ) && ( Buffer[2] == 0xBF ) );
  return result;
}


bool __fastcall IsFileRTF( void* h )
{
  bool result = false;
  const char sign[] = "{\\rtf";
  const int SignLen = strlen( sign );
  #pragma pack(push, 1)
  char Buffer[ 6/*# range 0..SignLen*/ ];
  #pragma pack(pop)
  DWORD BytesRead = 0;
  FillChar( Buffer, sizeof( Buffer ), 0 );
  SetFilePointer( h, 0, NULL, FILE_BEGIN );
  /*$WARNINGS OFF*/
  result = ReadFile( h, Buffer, SignLen, &BytesRead, NULL ) && ( BytesRead >= SignLen ) && ( Buffer == sign );
  /*$WARNINGS ON*/
  return result;
}


bool __fastcall IsFileWeb( void* h )
{
  bool result = false;
  const char sign[] = "<?xml";
  const int SignLen = strlen( sign );
  #pragma pack(push, 1)
  char Buffer[ 6/*# range 0..SignLen*/ ];
  #pragma pack(pop)
  DWORD BytesRead = 0;
  FillChar( Buffer, sizeof( Buffer ), 0 );
  SetFilePointer( h, 0, NULL, FILE_BEGIN );
  /*$WARNINGS OFF*/
  result = ReadFile( h, Buffer, SignLen, &BytesRead, NULL ) && ( BytesRead >= SignLen ) && ( Buffer == sign );
  /*$WARNINGS ON*/
  return result;
}


void __fastcall IsFileRTFAndUTF8( const WideString AFileName, bool& IsRTF, bool& IsUTF8 )
{
  void* h = 0;
  IsRTF = false;
  IsUTF8 = false;
  h = FFileOpen( AFileName );
  if ( h != INVALID_HANDLE_VALUE )
    try
    {
      IsRTF = IsFileRTF( h );
      IsUTF8 = IsFileUTF8( h );
    }
    __finally
    {
      CloseHandle( h );
    }
}



typedef int TFreqTable [ 128/*# range 0x80..0xFF*/ ];


bool __fastcall IsFileText( void* h, DWORD BufSizeKb, bool DetectOEM, bool& IsOEM )
{
  bool result = false;
  char* Buffer = NULL;
  DWORD BufSize = 0, BytesRead = 0, i = 0;
  int n = 0;
  TFreqTable Table;
  int TableSize = 0;
  result = false;
  IsOEM = false;
  if ( BufSizeKb == 0 )
    return result;
  Buffer = NULL;
  BufSize = BufSizeKb * 1024;

  //Init freq table
  TableSize = 0;
  FillChar( Table, sizeof( Table ), 0 );
  try
  {
    GetMem( Buffer, BufSize );
    FillChar( Buffer, BufSize, 0 );
    SetFilePointer( h, 0, NULL, FILE_BEGIN );
    if ( ReadFile( h, Buffer, BufSize, &BytesRead, NULL ) )
      if ( BytesRead > 0 )
      {
        result = true;
        for ( int stop = BytesRead - 1, i = 0; i <= stop; i++)
        {
          n = int( Buffer[i] );

          //If control chars present, then non-text
          if ( ( n < 32 ) && ( n != 9 ) && ( n != 13 ) && ( n != 10 ) )
          {
            result = false;
            break;
          }

          //Calculate freq table
          if ( DetectOEM )
            if ( ( n >= /*# Low( Table ) */ 128 ) && ( n <= /*# High( Table ) */ 255 ) )
            {
              TableSize++;
              Table[n - 128]++;
            }
        }
      }

    //Analize table
    if ( DetectOEM )
      if ( result && ( TableSize > 0 ) )
        for ( int stop = /*# High( Table ) */ 255, i = /*# Low( Table ) */ 128; i <= stop; i++)
        {
          Table[i - 128] = Table[i - 128] * 100 / TableSize;
          if ( ( ( i >= 0xB0 ) && ( i <= 0xDF ) ) || ( i == 0xFF ) || ( i == 0xA9 ) )
            if ( Table[i - 128] >= 18 )
            {
              IsOEM = true;
              break;
            }
        }
  }
  __finally
  {
    if (( Buffer != NULL ) )
      FreeMem( Buffer, -1 );
  }
  return result;
}


void __fastcall SAddSlash( AnsiString& S )
{
  if ( ( !S.IsEmpty()) && ( S[S.Length( )] != '\\' ) )
    S = S + "\\";
}


AnsiString __fastcall FFileNameWideToAnsi( const WideString Filename )
{
  AnsiString result;
  if ( IsDirExist( Filename ) )
  {
    result = Filename;
    //Convert to short form only "pure Unicode" names:
    if ( Filename != ((WideString) ((AnsiString) Filename ) ) )
    {
      result = FGetShortName( Filename );
      if ( ! IsDirExist( result ) )
        result = "";
    }
    //Add trailing slash, Lister plugins expect it:
    SAddSlash( result );
  }
  else
  {
    result = Filename;
    //Convert to short form only "pure Unicode" names:
    if ( Filename != ((WideString) ((AnsiString) Filename ) ) )
    {
      result = FGetShortName( Filename );
      if ( ! IsFileAccessed( result ) )
        result = "";
    }
  }
  return result;
}


WideString __fastcall FFindFirstFile( const WideString DirName, const WideString Mask )
{
  WideString result;
  void* h = 0;
  TWin32FindDataA fdA;
  TWin32FindDataW fdW;
  bool IsDir = false;
  result.Empty();
  h = INVALID_HANDLE_VALUE;
  try
  {
    if ( Win32Platform == VER_PLATFORM_WIN32_NT )
    {
      h = FindFirstFileW( WideString( DirName + L"\\" + Mask ).c_bstr( ), &fdW );
      if ( h != INVALID_HANDLE_VALUE )
        do
        {
          IsDir = ( ( fdW.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) ) != 0;
          if ( ! IsDir )
          {
            result = DirName + L"\\" + fdW.cFileName;
            return result;
          }
        }
        while ( ! ( ! FindNextFileW( h, &fdW ) ) );
    }
    else
    {
      h = FindFirstFileA( ((AnsiString) ( DirName + L"\\" + Mask ) ).c_str(), &fdA );
      if ( h != INVALID_HANDLE_VALUE )
        do
        {
          IsDir = ( ( fdA.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) ) != 0;
          if ( ! IsDir )
          {
            result = DirName + L"\\" + fdA.cFileName;
            return result;
          }
        }
        while ( ! ( ! FindNextFileA( h, &fdA ) ) );
    }
  }
  __finally
  {
    /*# Windows */::FindClose( h );
  }
  return result;
}


bool __fastcall FDeleteToRecycleA( void* Handle, const AnsiString Filename, bool ToRecycle )
{
  bool result = false;
  TSHFileOpStructA op;
  AnsiString SFrom;
  SFrom = Filename + "\x00\x00";
  FillChar( &op, sizeof( op ), 0 );
  op.hwnd = Handle;
  op.wFunc = FO_DELETE;
  op.pFrom = SFrom.c_str();
  op.fFlags = FOF_NOCONFIRMATION;
  if ( ToRecycle )
    op.fFlags = op.fFlags | FOF_ALLOWUNDO;
  result = SHFileOperationA( &op ) == 0;
  return result;
}


bool __fastcall FDeleteToRecycleW( void* Handle, const WideString Filename, bool ToRecycle )
{
  bool result = false;
  TSHFileOpStructW op;
  WideString SFrom;
  SFrom = Filename + L"\x00\x00";
  FillChar( &op, sizeof( op ), 0 );
  op.hwnd = Handle;
  op.wFunc = FO_DELETE;
  op.pFrom = SFrom.c_bstr();
  op.fFlags = FOF_NOCONFIRMATION;
  if ( ToRecycle )
    op.fFlags = op.fFlags | FOF_ALLOWUNDO;
  result = SHFileOperationW( &op ) == 0;
  return result;
}


bool __fastcall FDeleteToRecycle( void* Handle, const WideString Filename, bool ToRecycle )
{
  bool result = false;
  if ( Win32Platform == VER_PLATFORM_WIN32_NT )
    result = FDeleteToRecycleW( Handle, Filename, ToRecycle );
  else
    result = FDeleteToRecycleA( Handle, Filename, ToRecycle );
  return result;
}


bool __fastcall FDelete( const WideString Filename )
{
  bool result = false;
  if ( Win32Platform == VER_PLATFORM_WIN32_NT )
    result = DeleteFileW( Filename.c_bstr());
  else
    result = DeleteFileA( ((AnsiString) Filename ).c_str());
  return result;
}


WideString __fastcall FGetFullPathName( const WideString Filename )
{
  WideString result;
  char bufA[ 260/*# range 0..MAX_PATH-1*/ ];
  wchar_t bufW[ 260/*# range 0..MAX_PATH-1*/ ];
  char* partA = NULL;
  wchar_t* partW = NULL;
  result.Empty();
  if ( !Filename.IsEmpty()) //Result for empty string_ should be empty string_!
    if ( Win32Platform == VER_PLATFORM_WIN32_NT )
    {
      if ( GetFullPathNameW( Filename.c_bstr(), sizeof( bufW ) / 2, bufW, &partW ) != 0 )
        result = bufW;
    }
    else
    {
      if ( GetFullPathNameA( ((AnsiString) Filename ).c_str(), sizeof( bufA ), bufA, &partA ) != 0 )
        result = ((AnsiString) bufA );
    }
  return result;
}


void __fastcall FShowPropertiesA( const AnsiString fn, void* HWND )
{
  TShellExecuteInfoA sei;
  FillChar( &sei, sizeof( sei ), 0 );
  sei.cbSize = sizeof( sei );
  sei.hwnd = HWND;
  sei.lpFile = fn.c_str();
  sei.lpVerb = "properties";
  sei.fMask = SEE_MASK_INVOKEIDLIST;
  ShellExecuteExA( &sei );
}


void __fastcall FShowPropertiesW( const WideString fn, void* HWND )
{
  TShellExecuteInfoW sei;
  FillChar( &sei, sizeof( sei ), 0 );
  sei.cbSize = sizeof( sei );
  sei.hwnd = HWND;
  sei.lpFile = ((PWChar) fn.c_bstr());
  sei.lpVerb = L"properties";
  sei.fMask = SEE_MASK_INVOKEIDLIST;
  ShellExecuteExW( &sei );
}


void __fastcall FShowProperties( const WideString fn, void* HWND )
{
  if ( Win32Platform == VER_PLATFORM_WIN32_NT )
    FShowPropertiesW( fn, HWND );
  else
    FShowPropertiesA( ((AnsiString) fn ), HWND );
}
