#ifndef ATxFProcH
#define ATxFProcH


#include "d2c_system.h"

#include <windows.hpp>



struct TInt64Rec;


bool __fastcall IsFileExist( const WideString Filename, bool& IsDir ) /*# overload */;
bool __fastcall IsFileExist( const WideString Filename ) /*# overload */;
bool __fastcall IsFileOrDirExist( const WideString Filename );
bool __fastcall IsDirExist( const WideString DirName );
bool __fastcall IsFileAccessed( const WideString Filename );
void* __fastcall FFileOpen( const WideString Filename );
bool __fastcall FFileCopy( const WideString OldName, const WideString newName );
bool __fastcall FFileMove( const WideString OldName, const WideString newName );
__int64 __fastcall FGetFileSize( const WideString Filename ) /*# overload */;
__int64 __fastcall FGetFileSize( void* Handle ) /*# overload */;
bool __fastcall FGetFileInfo( const WideString Filename, __int64& Size, TFileTime& Time );
WideString __fastcall FGetShortName( const WideString Filename );
WideString __fastcall FGetFullPathName( const WideString Filename );


typedef TInt64Rec* PInt64Rec;

#pragma pack(push, 1)
struct TInt64Rec {
  DWORD Lo, Hi;
};
#pragma pack(pop)


bool __fastcall FOpenURL( const WideString URL, void* HWND );
bool __fastcall FExecute( const WideString Command, const WideString Params, void* HWND );
bool __fastcall FCreateDir( const WideString Filename );
bool __fastcall IsFileUnicode( void* h );
bool __fastcall IsFileUTF8( void* h );
bool __fastcall IsFileRTF( void* h );
bool __fastcall IsFileWeb( void* h );
void __fastcall IsFileRTFAndUTF8( const WideString AFileName, bool& IsRTF, bool& IsUTF8 );
bool __fastcall IsFileText( void* h, DWORD BufSizeKb, bool DetectOEM, bool& IsOEM );

//Convertion of Unicode filename to ANSI one:
//1. Trying to simply convert Unicode string_ to ANSI
//2. If not successfull, trying to get short name, it's always ANSI
//3. If not successfull, function returns empty string_ (fails)

AnsiString __fastcall FFileNameWideToAnsi( const WideString Filename );
WideString __fastcall FFindFirstFile( const WideString DirName, const WideString Mask );
bool __fastcall FDelete( const WideString Filename );
bool __fastcall FDeleteToRecycle( void* Handle, const WideString Filename, bool ToRecycle = true );
void __fastcall FShowProperties( const WideString fn, void* HWND );

#endif //  ATxFProcH