
/**************************************************/
/*                                                */
/*  ATFileNotification Component                  */
/*  Copyright (C) 2006-2007 Alexey Torgashin      */
/*  http://atorg.net.ru                           */
/*  support@uvviewsoft.com                        */
/*                                                */
/**************************************************/

/*
ATFileNofitication is a modification of fisFileNotifaction component, which was
originally written by FIS House and is available on http://www.torry.net.
In 2006 year I could not contact FIS House about their original component,
since their home site www.fishouse.com was down.

Original copyright was:
------------------------------------------------------------------------------
 Unit     : fisFileNotifaction.pas
 Purpose  : File notification component
 Status   :
 Copyright: 2000 First Internet Software House, http://www.fishouse.com
 Contact  : support@fishouse.com
-------------------------------------------------------------------------------
*/

/*$BOOLEVAL OFF*/ //Short boolean evaluation.
#ifndef ATFileNotificationH
#define ATFileNotificationH


#include "d2c_system.h"

#include <windows.hpp>
#include <messages.hpp>
#include <sysutils.hpp>
#include <classes.hpp>
#include <controls.hpp>
#include <extctrls.hpp>



#define ATFileNotification__0 ( TATFileNotifyOptions () \
                     << TATFileNotifyOption ( 0 ) << TATFileNotifyOption ( 1 ) << TATFileNotifyOption ( 4 ) )
class TATFileNotification;




enum TATFileNotifyOption {foNotifyFilename,
                          foNotifyDirname,
                          foNotifyAttributes,
                          foNotifySize,
                          foNotifyLastWrite,
                          foNotifyLastAccess,
                          foNotifyCreation,
                          foNotifySecurity };
typedef System::Set < TATFileNotifyOption, foNotifyFilename, foNotifySecurity > TATFileNotifyOptions;
extern DWORD cATFileNotifyFlags [ 8 /*# TATFileNotifyOption */ ];


class TATFileNotification: public TComponent {
  typedef TComponent inherited;
  private:
    /* Private declarations */
  bool FStarted;
  bool FSubtree;
  TATFileNotifyOptions fOptions;
  WideString FDirectory;
  WideString FFileName;
  TNotifyEvent FOnChanged;
  TThread* FDirThread;
  TTimer* FTimer;
  TRTLCriticalSection FLock;
  void __fastcall SetDirectory( const WideString ADirectory );
  void __fastcall SetFileName( const WideString AFileName );
  void __fastcall Timer( TObject* Sender );
  void __fastcall SetEnabled( bool AValue );
  protected:
    /* Protected declarations */
  public:
    /* Public declarations */
  __fastcall TATFileNotification( TComponent* AOwner );
  __fastcall virtual ~TATFileNotification( );
  void __fastcall Start( );
  void __fastcall Stop( );
  __property bool Enabled = { read = FStarted, write = SetEnabled };
  __published:
    /* Published declarations */
  __property TNotifyEvent OnChanged = { read = FOnChanged, write = FOnChanged };
  __property TATFileNotifyOptions Options = { read = fOptions, write = fOptions, default = /*# ATFileNotification__0 */ 19 };
  __property bool Subtree = { read = FSubtree, write = FSubtree, default = false };
  __property WideString Directory = { read = FDirectory, write = SetDirectory };
  __property WideString Filename = { read = FFileName, write = SetFileName };
};


extern AnsiString sMsgNotifError;
extern AnsiString sMsgNotifExceptionWait;
extern AnsiString sMsgNotifExceptionCreate;
extern AnsiString sMsgNotifExceptionTerminate;
void __fastcall Register( );

#endif //  ATFileNotificationH