
/**************************************************/
/*                                                */
/*  ATStreamSearch Component                      */
/*  Copyright (C) 2007-2008 Alexey Torgashin      */
/*  http://atorg.net.ru                           */
/*  support@uvviewsoft.com                        */
/*                                                */
/**************************************************/

/*$BOOLEVAL OFF*/ //Short boolean evaluation required.

//ATStreamSearch options:

//{$define REGEX} //Enable RegEx search (DIRegEx library).

//{$define TNT} //Enable unicode filenames support during search - 
                //Tnt Unicode Controls are used for that.
 //ATStreamSearch options.
#ifndef ATStreamSearchH
#define ATStreamSearchH


#include "d2c_system.h"

#include <windows.hpp>
#include <classes.hpp>
#include "ATxCodepages.h"



class TATStreamSearch;




enum TATStreamSearchOption {asoCaseSens,
                            asoWholeWords,
                            asoBackward,
                            asoFromPage };
typedef System::Set < TATStreamSearchOption, asoCaseSens, asoFromPage > TATStreamSearchOptions;
typedef void __fastcall ( __closure * TATStreamSearchProgress )( const __int64, const __int64, bool& );


class TATStreamSearch: public TComponent {
  typedef TComponent inherited;
  private:
  TStream* FStream;
  bool FStreamOwner;
  WideString FFileName;
  __int64 FStreamStart;
  __int64 FStreamSize;
  __int64 FFoundStart;
  __int64 FFoundLength;
  TATStreamSearchProgress FOnProgress;
  int FCharSize;
  WideString FSavedText;
  TATEncoding FSavedEncoding;
  TATStreamSearchOptions FSavedOptions;
    //FSearchForValidUTF16: Boolean;
  void __fastcall FreeStream( );
  void __fastcall InitSavedOptions( );
  bool __fastcall InitProgressFields( const __int64 AStartPos, TATEncoding AEncoding );
  void __fastcall DoProgress( const __int64 ACurrentPos, const __int64 AMaximalPos, bool& AContinueSearching );
  void __fastcall SetFileName( const WideString AFileName );
  void __fastcall SetStream( TStream* AStream );
  __int64 __fastcall TextFind( const WideString AText, const __int64 AStartPos, TATEncoding AEncoding, TATStreamSearchOptions AOptions );
  bool __fastcall TextFindFirst( const WideString AText, const __int64 AStartPos, TATEncoding AEncoding, TATStreamSearchOptions AOptions );
  bool __fastcall TextFindNext( bool AFindPrevious = false );
  public:
  __fastcall TATStreamSearch( TComponent* AOwner );
  __fastcall virtual ~TATStreamSearch( );
  __property WideString Filename = { read = FFileName, write = SetFileName };
  __property TStream* Stream = { read = FStream, write = SetStream };
  bool __fastcall FindFirst( const WideString AText, const __int64 AStartPos, TATEncoding AEncoding, TATStreamSearchOptions AOptions );
  bool __fastcall FindNext( bool AFindPrevious = false );
  __property __int64 FoundStart = { read = FFoundStart };
  __property __int64 FoundLength = { read = FFoundLength };
  __property WideString SearchString = { read = FSavedText };
  __published:
    //property SearchForValidUTF16: Boolean read FSearchForValidUTF16 write FSearchForValidUTF16 default False;
  __property TATStreamSearchProgress OnProgress = { read = FOnProgress, write = FOnProgress };
};


extern AnsiString MsgATStreamSearchRegExError;
extern AnsiString MsgATStreamSearchReadError;
void __fastcall Register( );

#endif //  ATStreamSearchH