
#include <vcl.h>
#pragma hdrstop

#include "ATxClipboard.h"



#include <windows.hpp>
#include <sysutils.hpp>



#include "d2c_system.h"


bool __fastcall SOpenAndClearClipboard( )
{
  bool result = false;
  result = OpenClipboard( 0 );
  if ( result )
    EmptyClipboard();
  return result;
}

//CF_UNICODETEXT format is supported only under NT



bool __fastcall SCopyToClipboardW_NT( const WideString S, bool DoClear )
{
  bool result = false;
  int DataSize = 0, BufferSize = 0;
  HGLOBAL hData = 0;
  void* gData = NULL;
  DataSize = S.Length( ) * 2;
  if ( DataSize > 0 )
  {
    if ( DoClear )
    {
      if ( ! SOpenAndClearClipboard() )
      {
        result = false;
        return result;
      }
    }
    BufferSize = DataSize + 2;
    hData = GlobalAlloc( GMEM_MOVEABLE | GMEM_DDESHARE, BufferSize );
    if ( hData != 0 )
    {
      gData = GlobalLock( hData );
      if ( gData != NULL )
      {
        Move( &S[1], gData, BufferSize );
        GlobalUnlock( hData );
        SetClipboardData( CF_UNICODETEXT, hData );
      }
    }
    if ( DoClear )
      CloseClipboard();
  }
  result = true;
  return result;
}


bool __fastcall SCopyToClipboard( const AnsiString S, TATEncoding Enc )
{
  bool result = false;
  int DataSize = 0, BufferSize = 0;
  HGLOBAL hData = 0;
  void* gData = NULL;
  AnsiString SCopy;
  int SFormat = 0;
  if ( S.Length( ) > 0 )
  {
    if ( ! SOpenAndClearClipboard() )
    {
      result = false;
      return result;
    }
    switch ( Enc )
    {
      case vEncANSI:
      {
        SCopy = S;
        SFormat = CF_TEXT;
      }
      break;
      case vEncOEM:
      {
        SCopy = S;
        SFormat = CF_OEMTEXT;
      }
      break;
    default:
    {
      SCopy = SCodepageToUnicode( S, Enc );
      SFormat = CF_TEXT;
    }
    }
    DataSize = SCopy.Length( );
    if ( DataSize == 0 )
    {
      result = true;
      return result;
    }
    BufferSize = DataSize + 1;
    hData = GlobalAlloc( GMEM_MOVEABLE | GMEM_DDESHARE, BufferSize );
    if ( hData != 0 )
    {
      gData = GlobalLock( hData );
      if ( gData != NULL )
      {
        Move( &SCopy[1], gData, BufferSize );
        GlobalUnlock( hData );
        SetClipboardData( SFormat, hData );
      }
    }

    //Also copy in CF_UNICODETEXT format for compatability with Windows controls
    if ( Win32Platform == VER_PLATFORM_WIN32_NT )
    {
      SCopyToClipboardW_NT( SCodepageToUnicode( S, Enc ), false );
    }
    CloseClipboard();
  }
  result = true;
  return result;
}


bool __fastcall SCopyToClipboardW( const WideString S )
{
  bool result = false;
  if ( Win32Platform == VER_PLATFORM_WIN32_NT )
    result = SCopyToClipboardW_NT( S, true );
  else
    result = SCopyToClipboard( ((AnsiString) S ), vEncANSI );
  return result;
}
