
//
// Codepages info:
// http://msdn2.microsoft.com/en-us/library/ms776446.aspx
//
#ifndef ATxCodepagesH
#define ATxCodepagesH


#include "d2c_system.h"

#include <windows.hpp>



#define ATxCodepages__0 ( System::Set < TATEncodingFamily, EncFamSystem, EncFamUnicode >() \
                     << TATEncodingFamily ( 5 ) << TATEncodingFamily ( 13 ) )
struct TATEncodingRec;




enum TATEncodingFamily {EncFamSystem,
                        EncFamWEuropean,
                        EncFamCEuropean,
                        EncFamBaltic,
                        EncFamCyrillic,
                        EncFamUS,
                        EncFamGreek,
                        EncFamLatin3,
                        EncFamTurkish,
                        EncFamArabic,
                        EncFamHebrew,
                        EncFamThai,
                        EncFamVietnam,
                        EncFamEBCDIC,
                        EncFamUTF,
                        EncFamUnicode };
extern System::Set < TATEncodingFamily, EncFamSystem, EncFamUnicode > cATEncodingNewRow;
    //Families which start new row in menu

extern AnsiString cATEncodingFamilyNames[ 16 /*# TATEncodingFamily */ ];


struct TATEncodingRec {
  int id;
  TATEncodingFamily Family;
  AnsiString Name;
};



enum TATEncoding {vEncANSI,
                  vEncOEM,
                  vEncEBCDIC,
                  vEncKOI8,
                  vEncISO,
                  vEncMac,
                  vEncWEuroDOS,
                  vEncWEuroISO1,
                  vEncWEuroISO2,
                  vEncWEuroMac,
                  vEncWEuroWin,
                  vEncCEuroDOS,
                  vEncCEuroISO,
                  vEncCEuroMac,
                  vEncCEuroWin,
                  vEncBalDOS,
                  vEncBalISO1,
                  vEncBalISO2,
                  vEncBalWin,
                  vEncCyrDOS,
                  vEncCyrISO,
                  vEncCyrKOI8R,
                  vEncCyrKOI8U,
                  vEncCyrMacC,
                  vEncCyrMacU,
                  vEncCyrWin,
                  vEncUSOEM,
                  vEncGreekDOS,
                  vEncGreekISO,
                  vEncGreekMac,
                  vEncGreekWin,
                  vEncLatin3,
                  vEncTurDOS,
                  vEncTurISO,
                  vEncTurMac,
                  vEncTurWin,
                  vEncArDOS1,
                  vEncArDOS2,
                  vEncArDOS3,
                  vEncArISO,
                  vEncArMac,
                  vEncArWin,
                  vEncHebDOS,
                  vEncHebISO1,
                  vEncHebISO2,
                  vEncHebMac,
                  vEncHebWin,
                  vEncThai,
                  vEncViet,
                  vEncEBUSCanada,
                  vEncEBInternational,
                  vEncEBLatin1,
                  vEncEBLatin2,
                  vEncEBGreek,
                  vEncEBGreekModern,
                  vEncEBGermany,
                  vEncEBDenmarkNorway,
                  vEncEBFinlandSweden,
                  vEncEBUnitedKingdom,
                  vEncEBFrance,
                  vEncEBIcelandic,
                  vEncEBCyrRussian,
                  vEncEBCyrSerbian,
                  vEncEBItaly,
                  vEncEBLatinAmerica,
                  vEncEBJapaneseKatExt,
                  vEncEBKoreanExt,
                  vEncEBArabic,
                  vEncEBHebrew,
                  vEncEBThai,
                  vEncEBTurkish,
                  vEncEBTurkishLatin5,
                  vEncUTF7,
                  vEncUTF8,
                  vEncUnicodeLE,
                  vEncUnicodeBE };
extern System::Set < TATEncoding, vEncANSI, vEncUnicodeBE > cATUnicodeEncodings;
extern TATEncodingRec cATEncodings [ 76 /*# TATEncoding */ ];
AnsiString __fastcall CodepageName( TATEncoding Enc );
bool __fastcall IsCodepageSupported( TATEncoding Enc );
WideString __fastcall SCodepageToUnicode( const AnsiString S, TATEncoding Enc );

#endif //  ATxCodepagesH